#ifndef __OEMTSUPPS_H__
#define __OEMTSUPPS_H__

/*============================================================================
FILE:  OEMTSupps.h

SERVICES:  OEM Telephony Supplementary Services.

GENERAL DESCRIPTION:
   Interface definitions, data structures, etc. to support BREW Telephony

        Copyright  2004 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR
*====*====*====*====*====*====*====*====*====*====*====*====*====*====*====*/


/*===========================================================================

                     INCLUDE FILES FOR MODULE

===========================================================================*/
#include "AEE.h"
#include "AEEModel.h"
#include "AEETelephone.h"


#ifdef __cplusplus
extern "C" {
#endif
int OEMSupps_ParseString(const char *pszString, AEETSuppsMessage *pMsg, uint32 *pdwSize);
int OEMSupps_SendMessage(AEETSuppsMessage *pMsg, ModelListener *pListener);
#ifdef __cplusplus
}
#endif

/*===================================================================== 
 INTERFACES   DOCUMENTATION
=======================================================================
OEMTSupps Interface
=======================================================================

Function: 

Description:
  
Prototype:
      
Parameters:

Return Value:

Comments:
   None

Side Effects:
   None

See Also:
   None

=======================================================================*/

#endif /* __OEMTSUPPS_H__ */
