//-------------------------------------------------------------------------------
//
//	FILE: my_MenuCtl.c
//
//	IMenu interfacẽCvO 
//
//-------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------------------+
//ŗ                                                                                                |
//--------+-----------+------------+--------------------------------------------------------+-------------+
//  No.   |  date     | [ԍ | ύX/Ce                                          |    name     |
//--------+-----------+------------+--------------------------------------------------------+-------------+
//  #000  | 05.xx.xx  |            | VK쐬                                               | O.Fukaya    |
//--------+-----------+------------+--------------------------------------------------------+-------------+
//  #001  | 05.04.08  |            | \j[C                                   | t.morishita |
//--------+-----------+------------+--------------------------------------------------------+-------------+
//  #002  | 05.04.08  |            | IMENUCTL_SetItem()sC                       | t.morishita |
//--------+-----------+------------+--------------------------------------------------------+-------------+
//  #003  | 05.05.04  |            | MCS_PARAM_DESCENDINGMCS_PARAM_ASCENDINGݒԈႢ    | N.Kanagawa  |
//--------+-----------+------------+--------------------------------------------------------+-------------+
//  #004  | 05.05.26  |            | IMENUCTL_SetProperties()MP_ICON_DELAY_IMAGE̐ݒC  | t.morishita |
//--------+-----------+------------+--------------------------------------------------------+-------------+
//  #005  | 05.06.09  |            | ONAsC                               | t.morishita |
//--------+-----------+------------+--------------------------------------------------------+-------------+
//  #006  | 05.06.17  |            | WSTRTOSTRWSTRCOMPRESSɏC                         | N.Kanagawa  |
//--------+-----------+------------+--------------------------------------------------------+-------------+
//        |           |            |                                                        |             |
//--------+-----------+------------+--------------------------------------------------------+-------------+

#include "come01.bid"
#include "MenuCtl.h"


//	AEEClsCreateInstance :: Avbg̍쐬
int AEEClsCreateInstance(AEECLSID ClsId,IShell * pIShell,IModule * po,void ** ppObj)
{
	//	Ɨpϐ̒`
	MyApp	*pApp = NULL ;
	*ppObj = NULL;
	
	// Class ID̊mF
	if ( ClsId == AEECLSID_COME01 )
	{
		if ( AEEApplet_New( sizeof(MyApp), ClsId, pIShell, po, (IApplet**)ppObj,
			(AEEHANDLER)myHandleEvent, (PFNFREEAPPDATA)myAppCleanup ) == TRUE )
		{
			pApp = (MyApp*)*ppObj;

			
			//	AppletCX^X̍쐬
			if ( FALSE == initMyApp(pApp) )
			{
				return  EFAILED;
			}
			
			return AEE_SUCCESS;
		}
	}
	
	//	Oo
	DBGPRINTF("ClsID is iligal.") ;
	return EFAILED;
}

//	initMyApp :: Avbg̏
boolean initMyApp(MyApp *pApp)
{
	// ƕϐ̒`
	AEEDeviceInfo	adi;
	int				nErr = 0;
	char			szBuf[MAX_LENGTH] = "";
	
	// NULL`FbN
	if( pApp == NULL )
	{
		DBGPRINTF( "pApp is NULL" );
		return FALSE;
	}
	
	// 
	pApp->m_pihv = NULL;
	pApp->pimc = NULL;
	pApp->m_piaLog = NULL;
	pApp->ncon = CON_DEFAULT;
	pApp->npro = 0;
	pApp->bMyPage = FALSE;
	
	ISHELL_GetDeviceInfo(pApp->app.m_pIShell, &adi);
	SETAEERECT(&pApp->arect, 0, 0, adi.cxScreen, adi.cyScreen - SIZE_ERRORLOG);

	
	nErr = ISHELL_CreateInstance(pApp->app.m_pIShell, AEECLSID_HTML, (void**)&pApp->m_pihv);
	if( nErr != SUCCESS )
	{
		IAUTOLOG_ErrorCheck( pApp->m_piaLog, nErr, szBuf, MAX_LENGTH );
		DBGPRINTF( "AEECLSID_HTML Ins %s", szBuf );
		return FALSE;
	}

	IHTMLVIEWER_SetRect(pApp->m_pihv, &pApp->arect);
	IHTMLVIEWER_SetNotifyFn(pApp->m_pihv, (PFNHVIEWNOTIFY)HtmlNotify_MENU, pApp);

	// IAutoLogCX^X
	nErr = ISHELL_CreateInstance(pApp->app.m_pIShell, AEECLSID_IAUTOLOG, (void**)&pApp->m_piaLog);
	if( nErr != SUCCESS )
	{
		DBGPRINTF( "AEECLSID_IAUTOLOG Ins 0x%x", nErr );
		return FALSE;
	}

	//Log
	if( InitAutoLog( pApp ) != SUCCESS )
	{
		DBGPRINTF("IAutoLog Init EFAILED");
		return  FALSE ;
	}

	return TRUE;
}

//	myAppCleanupCX^X̏I
void myAppCleanup(MyApp* pApp)
{
	//Log֌W
	EndAutoLog( pApp );
	// eCX^X̎QƃJE^̃fNg
	if( pApp->m_pihv != NULL )
	{
		ReleaseI((void **)&pApp->m_pihv);
	}
	if( pApp->pimc != NULL )
	{
		ReleaseI((void **)&pApp->pimc);
	}
	if( pApp->m_piaLog != NULL )
	{
		ReleaseI((void **)&pApp->m_piaLog);
	}
}

//	ReleaseI :: ėp֐
uint32 ReleaseI(void **ppif)
{
	uint32	nRes = 0;

	if (*ppif)
	{
		nRes = IBASE_Release((IBase*)*ppif);
		*ppif = 0;
	}
	return nRes;
}

//	MainHtml :: Jn̉ʍ쐬
void MainHtml(MyApp *pApp)
{
	char	szHtml[] = { 
		"== come01 MENU ==<br>"								// Cj[
		"<a href=1001>1.{mF</a><br>"				// 1.{mF
		"<a href=1002>2.Rg[mF</a><br>"				// 2.Rg[mF
		"<a href=1003>3.O""\x95""\x5c""</a><br>"		// 3.O\
		"<a href=1004>4.ONA</a><br>"					// 4.ONA
		"<br>"												//
		"<a href=1005>5.AvI</a><br>"					// 5.AvI
		"<br>"												//
	};


	pApp->bMyPage = TRUE;
	IHTMLVIEWER_SetRect(pApp->m_pihv, &pApp->arect);
	IHTMLVIEWER_ParseBuffer( pApp->m_pihv, szHtml );

	return;
}


//	ShowMainMenu :: {ʂ̍쐬
void ShowMainMenu(MyApp *pApp)
{
	// ƕϐ̒`
	char pszHtmlData[] = {
		"Main Menu<BR>"
		"<FORM METHOD=POST ACTION=1001>"
		"<HR>"
		"<P>CTLI<BR>"
		"<INPUT TYPE=radio NAME=ctype VALUE=menu CHECKED> MENUCTL <BR>"
		"<INPUT TYPE=radio NAME=ctype VALUE=list> LISTCTL <BR>"
		"<INPUT TYPE=radio NAME=ctype VALUE=icon> ICONVIEWCTL <BR></P>"
		"<CENTER><INPUT TYPE=SUBMIT VALUE=OK></FORM>"
	};

	// NULL`FbN
	if( pApp == NULL )
	{
		DBGPRINTF("pApp is NULL");
		return;
	}

	if( pApp->m_pihv == NULL )
	{
		DBGPRINTF("IHtmlViewerCX^X is NULL");
		return;
	}

	pApp->bMyPage = TRUE;

	//	HTML̕`͈͂ύX
	IHTMLVIEWER_SetRect(pApp->m_pihv, &pApp->arect);
	IHTMLVIEWER_ParseBuffer(pApp->m_pihv, pszHtmlData);
}

//	HtmlNotify_MENU :: HTMLVIEWERbZ[Wnh
void HtmlNotify_MENU(MyApp *pApp, HViewNotify *phvn, AEEEvent eCode, uint16 wParam, uint32 dwParam)
{
	// ƕϐ̒`
	char pszBuf[MAX_LENGTH]="";
	boolean bRet = FALSE;
	// NULL`FbN
	if( pApp == NULL )
	{
		DBGPRINTF("pApp is NULL");
		return;
	}

	if( pApp->m_pihv == NULL )
	{
		DBGPRINTF("IHtmlViewerCX^X is NULL");
		return;
	}

	switch( phvn->code )
	{
	case HVN_JUMP:
		switch( ATOI( phvn->u.submit.pszURL ) )
		{
		case 1001:
			//{mF
			bRet =  menuMain_item1( pApp );
			// AvԑJ
			MoveState( pApp, LOG_ADDREF_REL );
			break;

		case 1002:
			//Rg[mF
			ShowMainMenu( pApp );
			MoveState( pApp, MENU_CTLSEL );
			break;

		case 1003:
			//O\
			bRet =  menuMain_item9( pApp );
			// AvԑJ
			MoveState( pApp, LOG_ALL_DISP );
			break;

		case 1004:
			//ONA
			bRet =  menuMain_item10( pApp );
			// AvԑJ
			MoveState( pApp, LOG_ALL_CLEAR );
			break;

		case 1005:
			//AvI
			//AvI
			ISHELL_CloseApplet( pApp->app.m_pIShell, FALSE );
			break ;
		default:
			break;
		}
			break;

	
	case HVN_SUBMIT:
		switch( ATOI( phvn->u.submit.pszURL ) )
		{
		case 1001:

			IAUTOLOG_GetParam(pApp->m_piaLog, phvn->u.submit.pszData, "ctype", pszBuf, MAX_LENGTH);
			pApp->bMyPage = FALSE;
			if( STRCMP(pszBuf, "menu") == 0 )
			{
				pApp->ctype = MENUCTL;
			}
			else if( STRCMP(pszBuf, "list") == 0 )
			{
				pApp->ctype = LISTCTL;
			}
			else if( STRCMP(pszBuf, "icon") == 0 )
			{
				pApp->ctype = ICONVIEWCTL;
			}
			
			if ( pApp->pimc != NULL )
			{
				test_Release( pApp, pApp->pimc );
			}
			
			if ( TRUE != CreateMenuCtl(pApp) )
			{
				DBGPRINTF( "CreateMenuCtl ERROR" );
			}
			
			MoveState( pApp, MENU_CTL );
			break;
		case 2001:
			IAUTOLOG_Debug( pApp->m_piaLog, pApp->m_pihv, phvn );
			break;
		default :
			break;
		}
		break;
	default :
		break;
	}
	
	return;
}

boolean InitAutoLog( MyApp  *pApp )
{
	int	nRet;
	
	//IAUTOLOG
	pApp->m_pifm = NULL;
	pApp->m_pif_log = NULL;
	pApp->m_nLogCount = 1;
	pApp->m_nDisplayLogCount = 1;
	pApp->m_bLogDispFlg = FALSE;
	
	MEMSET(pApp->m_szHtmlBuf, NULL, BUFSIZE_HTML);
	
	if ( IAUTOLOG_Management(pApp->m_piaLog, AUTOLOG_PATH ) != IAUTOLOG_SUCCESS )
	{
		DBGPRINTF("AUTOLOG_Management FAILED");
		return (EFAILED) ;
	}
	
	// IFileMgrCX^X
	if (ISHELL_CreateInstance(pApp->app.m_pIShell, AEECLSID_FILEMGR, (void**)&pApp->m_pifm)
		!= SUCCESS)
	{
		DBGPRINTF("IFileMgr CreateInstance EFAILED");
		return (EFAILED);
	}
	
	//Ot@C̍쐬
	nRet = IFILEMGR_Test(pApp->m_pifm, LOG_FILE);
	if ( nRet == SUCCESS )
	{
		nRet = IFILEMGR_Remove(pApp->m_pifm,LOG_FILE);
		if( nRet != SUCCESS)
		{
			DBGPRINTF("LOGFILE DELETE ERROR %s", LOG_FILE);
			return (EFAILED);
		}
	}
	pApp->m_pif_log = IFILEMGR_OpenFile(pApp->m_pifm, LOG_FILE, _OFM_CREATE);
	if ( pApp->m_pif_log == NULL )
	{
		DBGPRINTF("LOGFILE OPEN ERROR %s", LOG_FILE);
		return (EFAILED);
	}
	IFILE_Write(pApp->m_pif_log,"<html><body></body></html>",26);
	
	return SUCCESS;

}

boolean	 EndAutoLog( MyApp  *pApp )
{
	AutoLogChain	*tmpLogChain;
	byte			*bTmp;
	
	//Log\NA
	if( pApp->m_AutoLogChain != NULL )
	{
		tmpLogChain = pApp->m_AutoLogChain;
		do{
	
			bTmp = (byte *)tmpLogChain->pNextPtr;
			FREEIF( tmpLogChain );
			tmpLogChain = (AutoLogChain *)bTmp;
	
		}while (tmpLogChain != NULL);
	}
	
	//
	if( pApp->m_pcReadBuf != NULL )
	{
		FREEIF( pApp->m_pcReadBuf );
	}
	
	//IFILEMGR̔j
	if( pApp->m_pifm != NULL )
	{
		IFILEMGR_Release( pApp->m_pifm ) ;
		pApp->m_pifm = NULL ;
	}
	
	//IFILE̔j
	if( pApp->m_pif_log != NULL )
	{
		IFILE_Release( pApp->m_pif_log ) ;
		pApp->m_pif_log = NULL ;
	}
	
	//	AUTOLOG̔j
	if( pApp->m_piaLog != NULL )
	{
		IAUTOLOG_Release( pApp->m_piaLog ) ;
		pApp->m_piaLog = NULL ;
	}
	
	return TRUE;
}

void LogDisp( MyApp *pApp )
{
	int		nRet=0;						//߂l
	char	aszBuf[ERR_BUF] = "";		// G[R[hi[
	uint32  unRes = 0;					//߂l
	int32	nLogSize = 0;				//f[^TCY
	FileInfo	fi;						//File
	AutoLogChain	*pAutoLogChain;		//Log\ptmp
	AutoLogChain	*pAutoLogChainNext;	//Log\ptmp
		
	//LOG\tOON
	pApp->m_bLogDispFlg = TRUE;
	
	MEMSET(pApp->m_szHtmlBuf,NULL,BUFSIZE_HTML);
	MEMSET(&fi, 0, sizeof(FileInfo));
	
	//t@C̏擾
	nRet = IFILE_GetInfo(pApp->m_pif_log, &fi);
	if( nRet != SUCCESS )
	{
		IAUTOLOG_ErrorCheck( pApp->m_piaLog, nRet, aszBuf, ERR_BUF );
		IAUTOLOG_FileWrite( pApp->m_piaLog, (pApp->m_piaLog, FALSE, "---۸ޓǂݍݎs---") );
		IAUTOLOG_FileWrite( pApp->m_piaLog, (pApp->m_piaLog, FALSE, "ERROR IFILE_GetInfo %s", aszBuf) );
		STRCAT( pApp->m_szHtmlBuf, "̧ق̓ǂݍ݂Ɏs܂<br>" );
		IHTMLVIEWER_ParseBuffer( pApp->m_pihv , pApp->m_szHtmlBuf ) ;
		IHTMLVIEWER_Redraw( pApp->m_pihv ) ; 
		return;
	}
	//t@C̐擪Ɉړ
	unRes = IFILE_Seek(pApp->m_pif_log, _SEEK_START, 0);
	if( unRes != SUCCESS )
	{
		IAUTOLOG_ErrorCheck( pApp->m_piaLog, unRes, aszBuf, ERR_BUF );
		IAUTOLOG_FileWrite( pApp->m_piaLog, (pApp->m_piaLog, FALSE, "---۸ޓǂݍݎs---") );
		IAUTOLOG_FileWrite( pApp->m_piaLog, (pApp->m_piaLog, FALSE, "ERROR IFILE_Seek %s", aszBuf) );
		STRCAT( pApp->m_szHtmlBuf, "̧ق̓ǂݍ݂Ɏs܂<br>" );
		IHTMLVIEWER_ParseBuffer( pApp->m_pihv , pApp->m_szHtmlBuf ) ;
		IHTMLVIEWER_Redraw( pApp->m_pihv ) ; 
		return;
	}
	
	//NULLȊO̓
	if( pApp->m_pcReadBuf != NULL )
	{
		FREEIF( pApp->m_pcReadBuf );
	}
	
	//t@C̃m
	pApp->m_pcReadBuf = (char *)MALLOC(( fi.dwSize + 1 ));
	if ( pApp->m_pcReadBuf == NULL )
	{
		IAUTOLOG_FileWrite( pApp->m_piaLog, (pApp->m_piaLog, FALSE, "---۸ޓǂݍݎs---") );
		IAUTOLOG_FileWrite( pApp->m_piaLog, (pApp->m_piaLog, FALSE, "ERROR MALLOC") );
		STRCAT( pApp->m_szHtmlBuf, "̧ق̓ǂݍ݂Ɏs܂<br>" );
		IHTMLVIEWER_ParseBuffer( pApp->m_pihv , pApp->m_szHtmlBuf ) ;
		IHTMLVIEWER_Redraw( pApp->m_pihv ) ; 
		FREEIF( pApp->m_pcReadBuf );
		return;
	}
	
	//t@C̓Ǎ
	nLogSize = IFILE_Read( pApp->m_pif_log, (void *)pApp->m_pcReadBuf, (fi.dwSize +1) );
	// Ǎݎs
	if( nLogSize == 0 )
	{
		IAUTOLOG_FileWrite( pApp->m_piaLog, (pApp->m_piaLog, FALSE, "---۸ޓǂݍݎs---") );
		IAUTOLOG_FileWrite( pApp->m_piaLog, (pApp->m_piaLog, FALSE, "ERROR IFILE_Read") );
		STRCAT( pApp->m_szHtmlBuf, "̧ق̓ǂݍ݂Ɏs܂<br>" );
		IHTMLVIEWER_ParseBuffer( pApp->m_pihv , pApp->m_szHtmlBuf ) ;
		IHTMLVIEWER_Redraw( pApp->m_pihv ) ; 
		FREEIF( pApp->m_pcReadBuf );
		return;
	}
	
	//t@C̐擪ʒuw
	pAutoLogChain = MALLOC( sizeof( AutoLogChain ) );
	if( pAutoLogChain == NULL )
	{
		FREEIF( pApp->m_pcReadBuf );
		return;
	}
	pAutoLogChain->pcLogPtr   = pApp->m_pcReadBuf;					//̐擪ʒu
	pAutoLogChain->nCharLen   = STRLEN(pAutoLogChain->pcLogPtr);	//
	pAutoLogChain->pBeforePtr = NULL;								//
	pAutoLogChain->pNextPtr   = NULL;								//
	pApp->m_AutoLogChain = pAutoLogChain;							//Log\pێ
	
	//y[W܂œǂݓǂ
	while( STRSTR( pAutoLogChain->pcLogPtr, "\n" ) != NULL ){
	
		pAutoLogChainNext = MALLOC( sizeof( AutoLogChain ) );							//̃y[ẄʒuێpGA擾
		pAutoLogChainNext->pcLogPtr   = STRSTR( pAutoLogChain->pcLogPtr, "\n" ) + 1;	//̃y[W̊Jnʒuێ
		pAutoLogChainNext->nCharLen   = STRLEN( pAutoLogChainNext->pcLogPtr );			//̃y[W̕񒷂ێ
		pAutoLogChainNext->pBeforePtr = pAutoLogChain;									//(̑O)̃y[WJnʒuێ
		pAutoLogChainNext->pNextPtr	  = NULL;											//̎̃y[Ẅʒu
	
		pAutoLogChain->pNextPtr = pAutoLogChainNext;										//̃y[Wݒ
		pAutoLogChain->nCharLen = pAutoLogChainNext->pcLogPtr - pAutoLogChain->pcLogPtr;	//̒ݒ
		pAutoLogChain = pAutoLogChainNext;													//̃y[WƗpɐݒ肷
	
	};
	
	//1y[Wڂ̕\e擾
	pApp->m_AutoLogDispNow = pApp->m_AutoLogChain;
	MEMSET(pApp->m_szHtmlBuf,NULL,BUFSIZE_HTML);
	MEMCPY( pApp->m_szHtmlBuf, pApp->m_AutoLogDispNow->pcLogPtr, pApp->m_AutoLogDispNow->nCharLen );
	
	//O̕\
	IHTMLVIEWER_ParseBuffer( pApp->m_pihv , pApp->m_szHtmlBuf );
	IHTMLVIEWER_Redraw( pApp->m_pihv ) ; 
	
	return;
}

void LogClear( MyApp *pApp )
{
	int		nRet=0;					//߂l
	char	aszOutput[BUF];			//o͗ptmp
	AutoLogChain	*tmpLogChain;
	byte			*bTmp;
	
	//Log\NA
	if( pApp->m_AutoLogChain != NULL ){
		tmpLogChain = pApp->m_AutoLogChain;
		do{
		
			bTmp = (byte *)tmpLogChain->pNextPtr;
			FREEIF(tmpLogChain );
			tmpLogChain = (AutoLogChain *)bTmp;
	
		}while (tmpLogChain != NULL);
// add sta 05.06.09 t.morishita #005
		pApp->m_AutoLogChain = NULL;
// add end 05.06.09 t.morishita #005
	}
	
	MEMSET(pApp->m_szHtmlBuf,NULL,BUFSIZE_HTML);
	nRet = IFILEMGR_Test(pApp->m_pifm, LOG_FILE);
	if ( nRet == SUCCESS )
	{	//t@C
		if( pApp->m_pif_log != NULL )
		{
			nRet = IFILE_Release( pApp->m_pif_log );
			pApp->m_pif_log = NULL;
			if ( nRet != 0)
			{
				DBGPRINTF("ERROR IFILE_Release");
				STRCAT( pApp->m_szHtmlBuf, "ERROR IFILE_Release<br>" );
				return;
			}
		}
		nRet = IFILEMGR_Remove(pApp->m_pifm, LOG_FILE);
		if( nRet != SUCCESS)
		{
			DBGPRINTF("LOGFILE DELETE ERROR %s", LOG_FILE);
			SPRINTF( aszOutput, "LOGFILE DELETE ERROR %s<br>", LOG_FILE);
			STRCAT( pApp->m_szHtmlBuf, aszOutput );
			return;
		}
	}
	pApp->m_pif_log = IFILEMGR_OpenFile(pApp->m_pifm, LOG_FILE, _OFM_CREATE);
	if ( pApp->m_pif_log == NULL )
	{
		DBGPRINTF("LOGFILE OPEN ERROR %s", LOG_FILE);
		SPRINTF( aszOutput, "LOGFILE OPEN ERROR %s<br>", LOG_FILE);
		STRCAT( pApp->m_szHtmlBuf, aszOutput );
		return;
	}
	IFILE_Write(pApp->m_pif_log,"<html><body></body></html>",26);
	STRCAT( pApp->m_szHtmlBuf, "۸ނر܂<br>" );
	IHTMLVIEWER_ParseBuffer( pApp->m_pihv , pApp->m_szHtmlBuf ) ;
	IHTMLVIEWER_Redraw( pApp->m_pihv ) ; 
	
	return;
}

void LogDispChange( MyApp *pApp, boolean next )
{
	if( pApp->m_AutoLogDispNow == NULL )
	{
		return;
	}
	
	if( pApp->m_AutoLogDispNow->pBeforePtr != NULL && next == BEFORE )		//Õy[W
	{
		pApp->m_AutoLogDispNow = pApp->m_AutoLogDispNow->pBeforePtr;
	
	}else if( pApp->m_AutoLogDispNow->pNextPtr != NULL && next == NEXT )	//̃y[W
	{
		pApp->m_AutoLogDispNow = pApp->m_AutoLogDispNow->pNextPtr;
	}else
	{
		return;
	}
	
	MEMSET(pApp->m_szHtmlBuf,NULL,BUFSIZE_HTML);
	MEMCPY( pApp->m_szHtmlBuf, pApp->m_AutoLogDispNow->pcLogPtr, pApp->m_AutoLogDispNow->nCharLen );
	
	//O̕\
	IHTMLVIEWER_ParseBuffer( pApp->m_pihv , pApp->m_szHtmlBuf );
	IHTMLVIEWER_Redraw( pApp->m_pihv ) ; 
	
	return;
}

// ---------------------------------------------------------
// ֐	: LogOutMake
// LOGo͍쐬
// ---------------------------------------------------------
boolean LogOutMake(MyApp  *pApp, boolean bDispFlag, boolean bTimeFlg, const char *pszFormat, ... )
{
	char		aszMesbuf[BUF];
	char		aszLogbuf[BUF];
	va_list		varg;
	int			nRet=0;
	char		aszReturn[5];
	
	MEMSET(aszMesbuf, NULL, BUF);
	MEMSET(aszLogbuf, NULL, BUF);
	MEMSET(aszReturn, NULL, sizeof(aszReturn));
	
	va_start( varg, pszFormat );
	VSPRINTF( aszMesbuf, pszFormat, varg );
	va_end( varg );
	
	//I[gOւ̏
	IAUTOLOG_FileWrite( pApp->m_piaLog, (pApp->m_piaLog, bTimeFlg, aszMesbuf) );
	
	//ݒ
	if( bTimeFlg == TRUE )
	{
		if( STRSTR( aszMesbuf , "START" ) != NULL )
		{	//START͐擪ɉsǉ
			SPRINTF( aszReturn, "<BR>" );
		}
	}
	
	//ݒ
	SPRINTF( aszLogbuf, "%s%s<BR>", aszReturn, aszMesbuf );
	
	//ʕ\
	if( bDispFlag == TRUE )
	{
		//sJEg
		pApp->m_nDisplayLogCount++;
	
		nRet = pApp->m_nDisplayLogCount % 200;
		if( nRet == 0 )
		{
			SPRINTF( aszLogbuf, "%s%s<BR>\n", aszReturn, aszMesbuf );
		}
		STRCAT( pApp->m_szHtmlBuf, aszLogbuf );
	}
	
	//ݒ
	SPRINTF( aszLogbuf, "%s%s<BR></body></html>", aszReturn, aszMesbuf );
	
	//sJEg
	pApp->m_nLogCount++;
	
	//Ot@Cւ̏
	nRet = pApp->m_nLogCount % 200;
	if( nRet == 0 )
	{
		SPRINTF( aszLogbuf, "%s%s<BR>\n</body></html>", aszReturn, aszMesbuf );
	}
	
	nRet = IFILE_Seek(pApp->m_pif_log,_SEEK_END,-14);
	if( nRet != SUCCESS )
	{
		return FALSE;
	}
	IFILE_Write(pApp->m_pif_log, aszLogbuf, STRLEN(aszLogbuf));
	
	return TRUE;
}

