//-------------------------------------------------------------------------------
//
//	FILE: menu.c
//
//	IMenuCtl interfacẽTuvO 
//
//-------------------------------------------------------------------------------

#include "MenuCtl.h"
#include "menu_res.h"
#include "main_res.h"

// Property_Menu :: Propertyl̑Ił郁j[Rg[̍쐬
void Property_Menu( MyApp *pApp )
{
	// ƕϐ̒`
	CtlAddItem		pcai;
	int				nf = TEST_FONT;
	
	// NULL`FbN
	if ( pApp == NULL )
	{
		DBGPRINTF( "pApp is NULL" );
		return;
	}
	
	if ( pApp->pimc == NULL )
	{
		DBGPRINTF( "IMenuCtlCX^X is NULL" );
		return;
	}
	
	// 
	disp_mng( pApp );
	
	// j[Rg[̃Zbg
	test_Reset( pApp );
	// IMENUCTL_SetRect()̎
	test_SetRect( pApp, &pApp->arect );
	// ^Cgݒ
	test_SetTitle( pApp, MENU_RES_FILE, PRO_TITLE, NULL );
	
	pcai.pText = NULL;
	pcai.pImage = NULL;
	pcai.wFont = nf;
	pcai.pszResImage = MAIN_RES_FILE;
	pcai.pszResText = MAIN_RES_FILE;
	
	switch ( pApp->ctype )
	{
	case MENUCTL:
		set_ProMenuMENU( pApp, &pcai );
		break;
	case LISTCTL:
		set_ProMenuLIST( pApp, &pcai );
		break;
	case ICONVIEWCTL:
		set_ProMenuICON( pApp, &pcai );
		break;
	default:
		break;
	}
	
	// j[ʃANeBu
	test_SetActive( pApp, TRUE );
	
	return;
}

//	Test_Menu :: vpeBleXgj[Rg[̍쐬
boolean Test_Menu( MyApp *pApp, uint32 flag )
{
	// ƕϐ̒`
	boolean			bRet = TRUE;
	int				nindex = TEST2_ID;
	int				nf = TEST_FONT;
	CtlAddItem		pcai;
	int				nLoop;
	uint32			unProp;

	// NULL`FbN
	if ( pApp == NULL )
	{
		DBGPRINTF( "pApp is NULL" );
		return FALSE;
	}
	if ( pApp->pimc == NULL )
	{
		DBGPRINTF( "IMenuCtl Ins is NULL" );
		return FALSE;
	}
	
	// 
	if ( flag != MP_NO_REDRAW )
	{
		disp_mng( pApp );
	}
	
	// 
	MEMSET( pApp->m_szHtmlBuf, NULL, BUFSIZE_HTML );
	MEMSET( &pcai, NULL, sizeof(CtlAddItem) );
	
	LogOutMake( pApp, TRUE, TRUE, "***Rg[mF START***" );
	Dispclsid( pApp );
	LogOutMake( pApp, TRUE, FALSE, "==Properties==" );
	
	// j[Rg[̃Zbg
	test_Reset( pApp );
	
	// IMENUCTL_SetRect()̎
	test_SetRect( pApp, &pApp->arect );
	
	// IMENUCTL_SetTitle()̎
	test_SetTitle( pApp, MENU_RES_FILE, TEST_TITLE, NULL );
	
	// IMENUCTL_SetProperties()̎
	if ( flag != 0xFFFFFFFF )
	{
		test_SetProperties( pApp, flag );
	}
	
	// IMENUCTL_GetProperties()̎
	test_GetProperties( pApp, &unProp );
	
	if ( flag == MP_MULTI_SEL )
	{
		IMENUCTL_SetFocus( pApp->pimc, (uint16)nindex );
	}
	
	pcai.wFont = (uint16)nf;
	pcai.pszResImage = MAIN_RES_FILE;
	pcai.pszResText = MENU_RES_FILE;
	
	for ( nLoop = 0; nLoop < 10; nLoop++ )
	{
		pcai.wText = TEST1 + nLoop;
		if ( flag == MP_ICON_ANIMATED )
		{
			pcai.wImage = BCI1 + nLoop;
		}
		else
		{
			pcai.wImage = IMAGE1 + nLoop;
		}
		pcai.wItemID = (uint16)nindex + nLoop;
		pcai.dwData = (uint32)nindex + nLoop;
		// IMENUCTL_AddItemEx()̎
		test_AddItemEx( pApp, &pcai );
	}
	
	// j[ʃANeBu
	test_SetActive( pApp, TRUE );
	
	return bRet;
}

//	Calendar_Menu :: J_[Cxg\̃j[Rg[̍쐬
void Calendar_Menu( MyApp *pApp, uint32 flag )
{
	// ƕϐ̒`
	int				nindex = TEST2_ID;
	int				nf = TEST_FONT;
	CtlAddItem		pcai;
	int				unstart;
	uint16			unduration = DURATION;
	uint32			untime;
	int				nLoop;
	uint32			unProp;
	
	// NULL`FbN
	if ( pApp == NULL )
	{
		DBGPRINTF( "pApp is NULL" );
		return;
	}
	if ( pApp->pimc == NULL )
	{
		DBGPRINTF( "IMenuCtl Ins is NULL" );
		return;
	}
	
	// 
	disp_mng( pApp );
	
	// 
	MEMSET( pApp->m_szHtmlBuf, NULL, BUFSIZE_HTML );
	
	LogOutMake( pApp, TRUE, TRUE, "***Rg[mF START***" );
	Dispclsid( pApp );
	LogOutMake( pApp, TRUE, FALSE, "==Properties==" );
	
	// j[Rg[̃Zbg
	test_Reset( pApp );
	
	// IMENUCTL_SetRect()̎
	test_SetRect( pApp, &pApp->arect );
	
	pcai.pText = NULL;
	pcai.pImage = NULL;
	pcai.wFont = (uint16)nf;
	pcai.pszResImage = MAIN_RES_FILE;
	pcai.pszResText = MENU_RES_FILE;
	
	// ݒ (ݎ-2h)
	untime = (GETTIMEMS() / 1000 / 60 / 60)-2;
	
	for ( nLoop = 0; nLoop < 13; nLoop++, untime++ )
	{
		pcai.wText = TEST1 + nLoop;
		pcai.wImage = IMAGE1 + nLoop;
		pcai.wItemID = (uint16)(nindex + nLoop);
		pcai.dwData = (uint32)(nindex + nLoop);
		
		test_AddItemEx( pApp, &pcai );
		
		unstart = untime * 60;
		
		// IMENUCTL_SetItemTime()̎
		test_SetItemTime( pApp, &pcai, unstart, unduration, flag );
		
		// IMENUCTL_GetItemTime()̎
		if ( flag == MP_CALENDAR )
		{
			test_GetItemTime( pApp, nindex + nLoop );
		}
	}
	
	if ( flag == MP_AUTOSCROLLTIME )
	{
		flag |= MP_CALENDAR;
	}
	// IMENUCTL_SetProperties()̎
	test_SetProperties( pApp, flag );
	
	// IMENUCTL_GetProperties()̎
	test_GetProperties( pApp, &unProp );
	
	// IMENUCTL_SetSel()̎
	test_SetSel( pApp, nindex+5 );
	
	// j[ʃANeBu
	test_SetActive( pApp, TRUE );
	
	// IMENUCTL_Redraw()̎
	test_Redraw( pApp );
	
	return;
}

//	Con_Menu :: TRUE/FALSȆIł郁j[Rg[̍쐬
void Con_Menu( MyApp *pApp )
{
	// ƕϐ̒`
	int				nindex = CON_ID;
	CtlAddItem		pcai;
	int				nf = TEST_FONT;
	int				nLoop;
	
	// NULL`FbN
	if ( pApp == NULL )
	{
		DBGPRINTF( "pApp is NULL" );
		return;
	}
	if ( pApp->pimc == NULL )
	{
		DBGPRINTF( "IMenuCtl Ins is NULL" );
		return;
	}
	
	// 
	disp_mng( pApp );
	
	// j[Rg[̃Zbg
	test_Reset( pApp );
	
	// IMENUCTL_SetRect()̎
	test_SetRect( pApp, &pApp->arect );
	
	// ^Cgݒ
	test_SetTitle( pApp, MENU_RES_FILE, CON_TITLE, NULL );
	
	pcai.pText = NULL;
	pcai.pImage = NULL;
	pcai.wFont = nf;
	pcai.pszResImage = MAIN_RES_FILE;
	pcai.pszResText = MENU_RES_FILE;
	
	for ( nLoop = 0; nLoop < 2; nLoop++ )
	{
		pcai.wText = CON1+nLoop;
		pcai.wImage = IMAGE1+nLoop;
		pcai.wItemID = (uint16)nindex+nLoop;
		pcai.dwData = (uint32)nindex+nLoop;
		// IMENUCTL_AddItemEx()̎
		test_AddItemEx( pApp, &pcai );
	}
	
	// IMENUCTL_SetSel()̎
	test_SetSel( pApp, nindex );
	
	// IMENUCTL_GetSel()̎
	test_GetSel( pApp );
	
	// j[ʃANeBu
	test_SetActive( pApp, TRUE );
	
	return;
}

//	Sort_Menu :: \[g̎ނIł郁j[Rg[̍쐬
void Sort_Menu( MyApp *pApp )
{
	// ƕϐ̒`
	int				nindex = SORT_ID;
	int				nf = TEST_FONT;
	CtlAddItem		pcai;
	int				nLoop;
	
	// NULL`FbN
	if ( pApp == NULL )
	{
		DBGPRINTF( "pApp is NULL" );
		return;
	}
	if ( pApp->pimc == NULL )
	{
		DBGPRINTF( "IMenuCtl Ins is NULL" );
		return;
	}
	
	// 
	disp_mng( pApp );
	
	// j[Rg[̃Zbg
	test_Reset( pApp );
	
	// O\
	LogOutMake( pApp, TRUE, TRUE, "***Rg[mF START***" );
	LogOutMake( pApp, TRUE, FALSE, "==Sort==");

	// IMENUCTL_SetRect()̎
	test_SetRect( pApp, &pApp->arect );
	
	// ^Cgݒ
	test_SetTitle( pApp, MENU_RES_FILE, SORT_TITLE, NULL );
	
	// j[ڏݒ
	pcai.pText = NULL;
	pcai.pImage = NULL;
	pcai.wFont = (uint16)nf;
	pcai.pszResImage = pcai.pszResText = MAIN_RES_FILE;
	
	for ( nLoop = 0; nLoop < 5; nLoop++ )
	{
		pcai.wText = SORT1+nLoop;
		pcai.wImage = IMAGE1+nLoop;
		pcai.wItemID = (uint16)nindex+nLoop;
		pcai.dwData = (uint32)nindex+nLoop;
		
		// ڐݒ
		test_AddItemEx( pApp, &pcai );
	}
	
	// j[ʃANeBu
	test_SetActive( pApp, TRUE );
	
	return;
}

