#ifndef BREWBASEAPPLET_H
#define BREWBASEAPPLET_H
/*===========================================================================
                          BrewBaseApplet.h

  BrewBaseApplet Implementation

  This file contains implementation of the BrewBaseApplet

        Copyright  1999-2002 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR
============================================================================*/
 /*===========================================================================

                        EDIT HISTORY FOR MODULE

when       who            what, where, why
--------   ----------     ---------------------------------------------------
06/04/04   ohmae@ISB      [PTX802-TRK4883]FLAPN[YJΉ
05/04/04   uehara@ISB     [PTX802-TRK1202-2] ۯPOPUPsreviewwEC
04/28/04   kunugi@ISB     [PTX802-TRK933] EZNAVIImFʕsΉ
                           VK쐬

// HISTORY      : -------- Tv -----------------------------------------------
// [ PTX-804 ]
//	Version	UIQ/TRK	OutLine
//	   0.08			PTX-804 BREW-20050329002 NJK q G
//						FeliCaNύXv]Ή
//     0.32 PTX-804 BREW-001-804TRK356F20050531001 NJK  p
//						BaseɂIdownLoadSendEvent\ɂ
//	   0.50 TRK2069	PTX-804 BREW101-TRK2069-20050621001 NJK  X
//						ҎAvNԐݒΉ
// [ PTX-805 ]
//	Version	UIQ/TRK	OutLine
//	00.06.00 UIQ-74	PTX-805 BREW201-20050831001 NJK  
//						PTMNʒǉ
//  00.07.00 UIQ152	PTX-805 BREW202-20050901001 NJK  p
//						PTM@\ǉ
//  00.15.00 		PTX-805 BREW203-20050929001 NJK R q
//						PCSVN[UCxgǉ
// [ PTX-805 ]
// Version	UIQ/TRK	OutLine
//	00.12.00		PTX-805 BREW301 BREW-20060116001 NJK  
//						IKDDIAppState_PauseApplet()dlύXΉ[No.70160]

===========================================================================*/

#include "AEE.h"
#include "BrewNap.h"

/* APIBREW˃x[XAvbg̃[UCxg` */
#define EVT_USER_ACTIVE_APPMGR			EVT_USER+1	/* AvP[V}l[WN	*/
#define EVT_USER_ACTIVE_MSHOP1			EVT_USER+2	/* oCVbvN				*/
#define EVT_USER_ACTIVE_MSHOP2			EVT_USER+3	/* oCVbvN				*/
#define EVT_USER_ACTIVE_HOTAPP			EVT_USER+4	/* ꔭNݒAvN			*/
#define EVT_USER_ACTIVE_TRANSIENT		EVT_USER+5	/* TransientAvN				*/
#define EVT_USER_ACTIVE_SHIM			EVT_USER+6	/* ShimAvN					*/
#define EVT_USER_DISPLAY_REDRAW			EVT_USER+7	/* ĕ`v						*/
#define EVT_USER_ACTIVE_GPCTRL			EVT_USER+8	/* GPRg[					*/
#define EVT_USER_ACTIVE_BAMF			EVT_USER+9	/* ڐGICj[N				*/
#define EVT_USER_ACTIVE_HIDDEN			EVT_USER+10	/* ێ烂[hN					*/
#define EVT_USER_ACTIVE_FSA				EVT_USER+11	/* OҊԒʐMAvN				*/
#define EVT_USER_ACTIVE_RST				EVT_USER+12	/* ZbgΉ						*/
#define EVT_USER_ACTIVE_HOTKEY_FELICA	EVT_USER+13	/* FeliCaꔭN					*/
#define EVT_USER_ACTIVE_ITEMIDCHECK		EVT_USER+14	/* IDOwnload ItemidCheck			*/
#define EVT_USER_ACTIVE_SCREENSAVER		EVT_USER+15	/* ҎAvN					*/
#define EVT_USER_ACTIVE_PTM				EVT_USER+16	/* PTMN							*/	/*** PTX-805 BREW201 ***/
#define EVT_USER_ACTIVE_PTM_SMS			EVT_USER+17	/* PTMN(SMS)					*/	/*** PTX-805 BREW201 ***/
#define EVT_USER_ACTIVE_IMP				EVT_USER+18	/* IMPN							*/	/*** PTX-805 BREW202 ***/
#define EVT_USER_ACTIVE_PCSV			EVT_USER+19	/* PCSVN							*/	/*** PTX-805 BREW203 ***/
#define EVT_USER_APP_REMOVE				EVT_USER+20	/* wAvbgI				*/	/*** PTX-808 BREW301 ***/

// NativeAgpp[^
typedef struct{
	int					NativeID;
	int					UserNo;
	void				*pUserData;
	ST_BREW_NAPPRM		*NapPrm;
	void 				(*pCallBackFunc)(int,void *,int);
}ST_BASE_NATIVESTART;

#endif   // BREWBASEAPPLET_H
