//******************************************************************************
// COPYRIGHT    : \j[GN\
// DIVISION     :
// AUTHOR       : \j[GN\
// FILENAME     : OEMDSRHTTP.h
//
// @(s) CONTENT : OEMDSRHTTPpwb_[
//
// VERSION      : $Revision:$
// HISTORY      : -------- Tv -----------------------------------------------
// [ PTX-805 ]
//	Version	UIQ/TRK	OutLine
//	00.10.00			PTX-805 BREW-20050916001 NJK œc ØY
//						VK쐬
//	00.12.00			PTX-804 BREW001-F20050928001 NJK œc ØY
//						HTTPʐMsC
//	00.12.00			PTX-804 BREW002-F20050929001 NJK œc ØY
//						HTTPʐMʎ擾sC
//	00.17.00			PTX-804 BREW003-F20051004001 NJK œc ØY
//						IKDDIDSR_SelectNetworkΉ
//	00.42.00			PTX-805 BREW004-805TRK799 F20051027001 NJK œc ØY
//						FXMLt@CrŐ؂ĂsΉ
//
//******************************************************************************

#ifndef	_INCLUDE_OEMDSR_HTTP
#define	_INCLUDE_OEMDSR_HTTP

#include "AEE.h"
#include "AEEWeb.h"
#include "IKDDIDSR.h"
#include "AEE_OEM.h"
#include "AEEStdlib.h"
#include "AEESource.h"

#include "ApiBrewApp.h"

// DSR HTTPʐMp\
typedef struct ST_DSRHTTP ST_DSRHTTP;

struct ST_DSRHTTP
{
	IWeb*					m_pIWeb;							// IWebC^tF[XIuWFNgւ̃|C^
	IWebResp*				m_pIWebResp;						// IWebRespC^tF[XIuWFNgւ̃|C^
	IPeek*					pipPostData;						// Post Stream

	KDDIDSRServer			DSRServerInfo;						// FT[o

	char				*	XMLData;							// Lv`ɂĎ擾XML̊i[
		                                                        // OEMDSR_HTTP_SetXMLData()֐ɂĐݒ

	int						XMLDataSize;						// Lv`ɂĎ擾XMLf[^̃TCY̊i[

	char				*	BodyData;							// Lv`ɂĎ擾HTMLBodyf[^̊i[
		                                                        // OEMDSR_HTTP_SetBodyData()֐ɂĐݒ

	int						BodyDataSize;						// Lv`ɂĎ擾HTMLBodyf[^TCY̊i[

	char				*	PostData;							// IWEB_GetResponse()ɂPOSTf[^̊i[

	int						PostDataSize;						// POSTf[^TCY̊i[

	void (* func1_cb)(void * UsrData, int status);								// HTTPʐM̏ԂωƂɌĂ΂R[obN֐|C^

	void (* func2_cb)(void * UsrData, int status, char * data, int length);		// HTTPʐMɌĂ΂R[obN֐|C^

	AEECallback				GetResponseCB;						// IWEB_GetResponse̊ɌĂ΂R[obN

	char				*    ResultXMLData;						// HTTPʐM̌ʂi[obt@

	int					     ResultXMLDataSize;					// HTTPʐM̌ʂi[obt@̃TCY											/*** PTX-805 BREW004 ***/

	int					     ReadOffset;						// ʎ擾̃ItZbg															/*** PTX-805 BREW004 ***/

	void				*    RetUsrData;						// HTTPʐMIɕԋpUsrData

	char				*    WebHeader;							// Webwb_i[B														/*** PTX-805 BREW001 ***/		

	char					strUrl[1024 + 1];					// T[oURLi[																	/*** PTX-805 BREW001 ***/

	AEECallback				ReadableCB;																												/*** PTX-805 BREW002 ***/

	WebRespInfo			*	resp;

	KDDIDSRNetInfo		    DSRNetInfo;							// PPPڑlbg[NihCj												/*** PTX-805 BREW003 ***/
};


// DSRHTTPʐMXe[^X
typedef enum
{
  DSRHTTP_CONNECT,
  DSRHTTP_DATA_SEND,
  DSRHTTP_HEADER_RECEIVE,
  DSRHTTP_BODY_RECEIVE,
} DSRHTTP_STATE;


// DSRHTTPʐMʃXe[^X
typedef enum
{
  DSRHTTP_SUCCESS,
  DSRHTTP_FAIL_OTHER,
  DSRHTTP_FAIL_PPP_CONNECT,
  DSRHTTP_FAIL_TCP_CONNECT,
  DSRHTTP_FAIL_SEND,
  DSRHTTP_FAIL_RECEIVE,
  DSRHTTP_CANCEL,
} DSRHTTP_RESULT_STATE;


// vg^Cv錾
int	OEMDSR_HTTP_Init(ST_DSRHTTP * pHttp);															
int	OEMDSR_HTTP_SetServer(ST_DSRHTTP * pHttp, KDDIDSRServer * Server);								
int OEMDSR_HTTP_GetResponse(ST_DSRHTTP * pHttp, void (* func1)(void *, int), void (* func2)(void *, int, char *, int), void * UsrData );		
int	OEMDSR_HTTP_Cancel(ST_DSRHTTP * pHttp);															
int	OEMDSR_HTTP_Release(ST_DSRHTTP * pHttp);														
int	OEMDSR_HTTP_SetXMLData(ST_DSRHTTP * pHttp, char * XMLData);										
//int	OEMDSR_HTTP_SetBodyData(ST_DSRHTTP * pHttp, char * BodyData);																			/*** PTX-805 BREW001 ***/					
int	OEMDSR_HTTP_SetBodyData(ST_DSRHTTP * pHttp, char * BodyData, int iBodyDataSize);															/*** PTX-805 BREW001 ***/
char *	OEMDSR_HTTP_GetXML(ST_DSRHTTP * pHttp);														
int	OEMDSR_HTTP_GetBodySize(ST_DSRHTTP * pHttp);													
int	OEMDSR_HTTP_PostDataSize(ST_DSRHTTP * pHttp);													
char *	OEMDSR_HTTP_GetPostData(ST_DSRHTTP * pHttp);												
int	OEMDSR_HTTP_SelectNetwork(ST_DSRHTTP * pHttp, KDDIDSRNetInfo * NetInfo);					/*** PTX-805 BREW003 ***/

void OEMDSR_HTTP_CreatePostData(ST_DSRHTTP * pHttp);										// HTTPNGXgɂPOSTf[^쐬
void OEMDSR_HTTP_ResultCB(void *p);															// IWEB_GetResponse()̏IʒmCB
void OEMDSR_HTTP_StatusHandler(ST_DSRHTTP * pHttp, WebStatus status, void * pData);			// HTTPʐMɃXe[^X̕ωꍇɃR[CB֐
void OEMDSR_HTTP_HeaderHandler(ST_DSRHTTP * pHttp, const char * pszName, GetLine * pgl);	// HTTPʐMIɃR[CB֐

void OEMDSR_HTTP_ReadableCB(void *p);															/*** PTX-805 BREW001 ***/

#endif		// _INCLUDE_OEMDSR_HTTP]

