#ifndef __OEMDIGITALSIGN_H__
#define __OEMDIGITALSIGN_H__

//******************************************************************************
// [ PTX-804 ]
//	Version	UIQ/TRK	OutLine
//	   0.09			PTX-804 BREW-20050401001 NJK  p
//						PKI OEM݌vύX
//*****************************************************************************/

#include "AEE.h"
#include "AEEWeb.h"
#include "AEEDigitalSign.h"
#include "OEMPKILib.h"
#include "SEMC_KCP.h"
#ifdef KCP_MERGE
#include "OEMNATIVEPrivate.h"
#endif


#define SHA_DIGEST_LENGTH 20

typedef struct _OEMDigitalSign OEMDigitalSign;


//struct IDigitalSign
struct _OEMDigitalSign
{
	const VTBL(IDigitalSign) * pvt;
	uint32 m_nRefs;
	AEECLSID m_clsid;

	//IDigitalSign_Release֐ɊJ邱ƂKv
	IShell * m_pIShell;
	IWebOpts * m_pIWebOpts;
	IWebUtil * piwu;

	AEECallback * pcb;
	DigitalSignStatus *status;

	int isSuccess;								//fW^ƎstO	0:s; 1:; 2:ss
/*** BREW105 ***///	unsigned int numRootCerts;					//[g̖ؖ
	unsigned long base64len;
	unsigned long msglen;
	int pkcs7bufflen;
	short certlen;								//NCAgؖf[^

	WIM_TChannelNumber channelNo;				//`lԍi[
	WIM_TInputData hash;						//fW^쐬̃p[[[^ƂMDZǒʂi[
/*** PTX-804 BREW101 START ***/
//	WIM_TInputData keyID;						//s҂Key IDi[
	WIM_TInputData dn;							//s҂Key IDi[
/*** PTX-804 BREW101 END ***/
	WIM_TCertificate certificate;				//LbV擾ؖi[

	// UIőIꂽؖݒ肳
	WIM_TClientCertificateInfo info;			//Iؖi[

	//WIM̊֐̏ʃR[h
//	WIM_TChannelNumberResult chn_result;		//WIM`lopenp

	//ȉ̕ϐ|C^́AJ邱ƂKv
	char* hashData;
	char* cert;									//NCAgؖf[^
	char* pkcs7buffer;
	X509* x509;
	X509_ATTRIBUTE* attribute;
	PKCS7* pkcs7;
	X509_ALGOR* algorithm;


	ASN1_TYPE *asn1type;

	PKCS7_SIGNER_INFO* signer_info;
	WIM_TOutputDataResult result;				//fW^WIM_ComputeDigitalSign()֐Ăяop
												//result.outputData.outputJ邱ƂKv

	char *DataMaloc;
	char *OctetData;
	char *EncDigestData;
	//ȉ̕ϐ͈ꎞp|C^A܂AJ邱ƂKv͂Ȃ
	char* msg;
	unsigned char* u_pkcs7buffer;
//	unsigned char* u_cert;

	/// IWeb ̃[gؖMALLOCĕۑ
/*** BREW105 ***///	WIM_TRootCertificate* Alloc_rootCerts;

	// WimDigitalSignCu
	WIMParam WIMprm;
	//INATIVE
	INATIVE * m_pINative;
};



#endif /* __OEMDIGITALSIGN_H__ */
