/******************************************************************************

   Copyright (c) 2005 by Sony Ericsson Mobile Communications(J).
                                            All Rights Reserved.

    [FileName]   OEMMpUtilAPI.h

    [Outline]    IMPUTIL BREW OEMAPI

    [history]	 05/07/17 myoshida@OTS  VK쐬
  		 06/02/24 OTS		812 KCPΉ
  
******************************************************************************/
#ifndef __OEMMPUTILAPI_H__
#define __OEMMPUTILAPI_H__

#include "AEE.h"
#include "AEEMpUtil.h"
#include "AEEMpUtilOM.h"
#include "AEEMpMulti.h"

#ifndef IMP_FULLPATH_LEN
#define IMP_FULLPATH_LEN        (259)
#endif

typedef struct _OEMMPUTILMediaDataParm {
    uint32	dwType;
    uint32	dwSize;
    uint32	dwOffset;
    uint32	dwDlinkID;
    uint32	dwFormat;
    char	szFilePath[IMP_FULLPATH_LEN+1];
} OEMMPUTILMediaDataParm;


// IMPUTIL OEM Methods
uint32  OEMMPUTIL_GetMediaDataParam4IMPCTL( IMPUtil* pIMPUtil, OEMMPUTILMediaDataParm * pOEMMPMulti );
uint32  OEMMPUTIL_GetFileInfo( char *pszFileName, AEEMPMultiFileInfo *pFileInfo );

// PTX808IMP_MSA mod 2006.1.17 yamamoto if1
void OEMMPUTIL_PlayEnd(IMPUtil *pIMPUtil);
// PTX808IMP_MSA mod 2006.1.17 yamamoto endif

// 812 KCPΉ[S]
void	CMPMULTI_Init( IShell * pIShell );
void	CMPUTIL_Init( IShell * pIShell );
void	CMPUTILOM_Init( IShell * pIShell );
// 812 KCPΉ[E]

#endif //__OEMMPUTILAPI_H__
