/*******************************************************************************
*                              Openwave Systems.                               *
*                            Device Products Group                             *
*                               Shinjuku, Tokyo                                *
****************************************************************************//**
   @file
   ̃}Nt@CExtensionɂăT|[gSẴpubN
   z֐\LAz֐̃eiXeՂɂ܂B̃}Nt@C
   ɐ錾̏Ԃς悤ȕύXȂłB<b>R[hj󂳂܂</b>B

*//*
   REVISION HISTORY:
   Date:       Who:               Email:
      - Details:
--------------------------------------------------------------------------------
   15 Nov 2004 kawa               yoshihiro.kawaguchi@openwave.com
      - Initial version

*******************************************************************************/
/*******************************************************************************
*                  Copyright (c) Openwave Systems 1995-2004                    *
*                            All rights reserved.                              *
*                                                                              *
*     THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Openwave Systems Inc.     *
*               The copyright notice above does not evidence any               *
*              actual or intended publication of such source code.             *
*******************************************************************************/

/*==============================================================================

	DUMMY DEFINES
	Blanks out anything that isn't defined when this macro file is included.

==============================================================================*/
/** @def FUNCTION
 ̃}N̓NXŃT|[g鉼z֐`̊Jn錾邽߂
 iombdev.mt@CŎgp܂B
 @param RETURNS ߂l^Cv  Fchar *, int, etc
 @param NAME ֐
*/
#ifndef FUNCTION
   #define FUNCTION( RETURNS, NAME )
#endif

/**@def NO_PARAM
 ̃}N͊֐ɈȂƂ錾邽߂ iombdev.mt@C
 Ŏgp܂B
 @param Ȃ
*/
#ifndef NO_PARAM
   #define NO_PARAM ///< void
#endif

/**@def FIRST_PARAM
 ̃}N͊֐ɑ錾邽߂ iombdev.mt@C
 Ŏgp܂B
 @param TYPE ^Cv  : char *, int, etc
 @param NAME 
*/
#ifndef FIRST_PARAM
   #define FIRST_PARAM( TYPE, NAME )
#endif

/**@def NEXT_PARAM
 ̃}N͊֐ɑȍ~ɑ錾邽߂ iombdev.mt@C
 Ŏgp܂B
 @param TYPE ^Cv : char *, int, etc
 @param NAME 
*/
#ifndef NEXT_PARAM
   #define NEXT_PARAM( TYPE, NAME )
#endif

/**@def END_FUNCTION
 ̃}N͊֐`̏I錾邽߂ iombdev.mt@C
 Ŏgp܂B
 @param Ȃ
*/
#ifndef END_FUNCTION
   #define END_FUNCTION	///< );
#endif


/*==============================================================================

	VIRTUAL FUNCTIONS

 ** DO NOT CHANGE THE ORDER OF THESE MACROS AS IT WILL BREAK THE SOFTWARE **

==============================================================================*/
//Make Doxygen ignore this next section (note in V1.4.4 we must use cond as
//Doxygen doesn't do pre-processing in *.m files, so #ifndef doesn't work).
///@cond DOXYGEN_WILL_IGNORE_THIS

//------------------------------------------------------------------------------
//--- This function must be first
//------------------------------------------------------------------------------
FUNCTION( uint32, lwIOMBDEV_AddRef )
FIRST_PARAM( tsIOMBDEV *, psIOMBDEV )
END_FUNCTION

//------------------------------------------------------------------------------
//--- This function must be second
//------------------------------------------------------------------------------
FUNCTION( uint32, lwIOMBDEV_Release )
FIRST_PARAM( tsIOMBDEV *, psIOMBDEV )
END_FUNCTION

//------------------------------------------------------------------------------
FUNCTION( boolean, InternalService )
FIRST_PARAM( tsIOMBDEV *, psIOMBDEV )
NEXT_PARAM( const char *, kcpURL )
NEXT_PARAM( const char *, kpcCallingUrl )
NEXT_PARAM( char *, pcSchema )
NEXT_PARAM( int *, piSchemalen )
NEXT_PARAM( void *, pvReqparam )
NEXT_PARAM( int *, piReqparamsize )
NEXT_PARAM( teOMBDEVServiceTypes *, peTypes )
END_FUNCTION

//------------------------------------------------------------------------------
FUNCTION( boolean, InternalServiceGetURL )
FIRST_PARAM( tsIOMBDEV *, psIOMBDEV )
NEXT_PARAM( const char *, kpcRequesturl )
NEXT_PARAM( void *, pvReference )
NEXT_PARAM( void *, pvReqparam )
NEXT_PARAM( int *, piReqparamsize )
END_FUNCTION

//------------------------------------------------------------------------------
FUNCTION( boolean, InternalServiceRelease )
FIRST_PARAM( tsIOMBDEV *, psIOMBDEV )
NEXT_PARAM( void *, pvReqparam )
END_FUNCTION

//------------------------------------------------------------------------------
FUNCTION( boolean, InternalServiceBackground )
FIRST_PARAM( tsIOMBDEV *, psIOMBDEV )
NEXT_PARAM( void *, pvBgparam )
NEXT_PARAM( tpfoNotifyResult, pfoNotifyResult )
NEXT_PARAM( void *, pvUser )
END_FUNCTION

//------------------------------------------------------------------------------
FUNCTION( void, CancelBackground )
FIRST_PARAM( tsIOMBDEV *, psIOMBDEV )
END_FUNCTION

//------------------------------------------------------------------------------
FUNCTION( boolean, InternalServiceFile )
FIRST_PARAM( tsIOMBDEV *, psIOMBDEV )
NEXT_PARAM( const char *, kpcUrl )
NEXT_PARAM( const char * *, kppcContentType )
NEXT_PARAM( char *, pcBuf )
NEXT_PARAM( int32 *, pwBuflen )
NEXT_PARAM( const char *, kpcCallingUrl )
END_FUNCTION

//------------------------------------------------------------------------------
FUNCTION( teOMBDEVDLValidateStatus, eDLValidateContext )
FIRST_PARAM( const char *, kpszFileName )
NEXT_PARAM( const char *, kpszFileType )
NEXT_PARAM( uint32, dwFileSize )
END_FUNCTION

//------------------------------------------------------------------------------
FUNCTION( const char *, kpczDLAcceptContext )
FIRST_PARAM( const char *, kpczFileType )
NEXT_PARAM( uint32 *, pdwMaxSize )
END_FUNCTION

//------------------------------------------------------------------------------
FUNCTION( boolean, oSaveAsValidateData )
FIRST_PARAM( void *, pvBuffer )
NEXT_PARAM( uint32, dwSize )
NEXT_PARAM( const char *, kpczExt )
END_FUNCTION

//------------------------------------------------------------------------------
FUNCTION( teOMBDEVPluginRedrawSequence, ePluginRedrawSequence )
FIRST_PARAM( AEECLSID , lwClsID )
END_FUNCTION


/*==============================================================================

	UNDEFINES
	Allows this macro file to be included multiple times

==============================================================================*/
#undef FUNCTION
#undef NO_PARAM
#undef FIRST_PARAM
#undef NEXT_PARAM
#undef END_FUNCTION

///@endcond -- DOXYGEN_WILL_IGNORE_THIS


