#ifndef OEMCLASSIDS_H
#define OEMCLASSIDS_H
/*======================================================
FILE:  AEEOEMClassIDs.h

SERVICES:  OEM specific class IDs

GENERAL DESCRIPTION:
   Base level definitions, typedefs, etc. for AEE

        Copyright  1999-2002 QUALCOMM Incorporated.
               All Rights Reserved.
            QUALCOMM Proprietary/GTDR
=====================================================*/

#include "AEEClassIDs.h"

#define AEECLSID_LAUNCHER          (AEECLSID_OEM_APP)
#define AEECLSID_UPBROWSER         (AEECLSID_BROWSER)
#define AEECLSID_UP4BROWSER        (AEECLSID_BROWSER)

#define AEECLSID_PROVISION_PRL     (AEECLSID_OEM + 0x100)             
#define AEECLSID_PROVISION_NAM     (AEECLSID_OEM + 0x101)
#define AEECLSID_PROVISION_CLOGO   (AEECLSID_OEM + 0x102)
#define AEECLSID_OEMBRIDGE         (AEECLSID_OEM + 0x103)
#define AEECLSID_DOWNSHIFT         (AEECLSID_OEM + 0x104)

#define AEECLSID_OEMADDRBOOK       (AEECLSID_OEM + 0x105)
#define AEECLSID_OEMRUIMADDRBOOK   (AEECLSID_OEM + 0x106)

/*=====================================================================
  DATA STRUCTURE DOCUMENTATION
=======================================================================
AEEOEMClassIDs

Description:


Definition:

#define AEECLSID_LAUNCHER          (AEECLSID_OEM_APP)
#define AEECLSID_UPBROWSER         (AEECLSID_BROWSER)
#define AEECLSID_UP4BROWSER        (AEECLSID_BROWSER)

#define AEECLSID_PROVISION_PRL     (AEECLSID_OEM + 0x100)             
#define AEECLSID_PROVISION_NAM     (AEECLSID_OEM + 0x101)
#define AEECLSID_PROVISION_CLOGO   (AEECLSID_OEM + 0x102)
#define AEECLSID_OEMBRIDGE         (AEECLSID_OEM + 0x103)
#define AEECLSID_DOWNSHIFT         (AEECLSID_OEM + 0x104)

#define AEECLSID_OEMADDRBOOK       (AEECLSID_OEM + 0x105)
#define AEECLSID_OEMRUIMADDRBOOK   (AEECLSID_OEM + 0x106)

Members:
None

See Also:
None

======================================================================*/

#endif   // OEMCLASSIDS_H


