#ifndef __AEECLIENTAUTH_H__
#define __AEECLIENTAUTH_H__
/*======================================================

FILE:  ClientAuth.h

SERVICES:
        ICientAuth

GENERAL DESCRIPTION:
        Enhanced IWeb interface.
        Handles SSL client auth internally.

=====================================================

      Copyright  1999-2002 QUALCOMM Incorporated 
              All Rights Reserved.
           QUALCOMM Proprietary/GTDR

=====================================================*/
#include "AEE.h"
#include "AEESource.h"
#include "AEEError.h"
#include "AEEWebOpts.h"
#include "AEEWeb.h"
#include "AEESecurity.h"
//makise[S]
//#include "../bid/ClientAuth.bid"
#include "OEMClassIDs.h"
//makise[E]

enum {
/* WEBS_STARTING = 0,
   WEBS_CANCELLED,
   WEBS_GETHOSTBYNAME,
   WEBS_CONNECT,
   WEBS_SENDREQUEST,
   WEBS_READRESPONSE,
   WEBS_GOTREDIRECT,
   WEBS_CACHEHIT,
   WEBS_PROGRESS,*/

   WEBS_SSL_STARTING = 0x10,
   WEBS_SSL_AUTHENTICATING,
   WEBS_SSL_END,
   WEBS_SSL_CANCELLED,

   WEBS_WIM_PROMPT_STARTING = 0x20,
   WEBS_WIM_PROMPT_END,
   WEBS_WIM_PROMPT_CANCELLED
};

#ifdef AEE_SIMULATOR
typedef unsigned ClientAuthStatus;
#else
typedef int8 ClientAuthStatus;
#endif

#endif //__AEECLIENTAUTH_H__
