#ifndef __AEEDIGITALSIGN_H__
#define __AEEDIGITALSIGN_H__
/*======================================================

FILE:  DigitalSign.h

SERVICES:
        IDigitalSign

=====================================================

      Copyright  1999-2002 QUALCOMM Incorporated 
              All Rights Reserved.
           QUALCOMM Proprietary/GTDR

=====================================================*/
#include "AEE.h"
#include "AEESource.h"
#include "AEEError.h"
#include "AEEWebOpts.h"
//makise[S]
//#include "DigitalSign.bid"
#include "OEMClassIDs.h"
//makise[E]

/*** PTX-804 BREW101 START ***/
//typedef struct _DigitalSignStatus{
//	byte* target;				//Ώۃf[^
//	uint32 targetLength;		//Ώۃf[^̃oCg
//	byte* keyID;				//s҂Key ID
//	uint32 keyIDLength;			//s҂Key ID̃oCg
//	byte* outBuffer;			//o̓obt@
//	uint32 bufferLength;		//o̓obt@̃obt@
//	uint32 outLength;			//o̓e[_
//	int result;					//ʃR[h
//} DigitalSignStatus;
typedef struct _DigitalSignStatus{
	byte* target;			//Ώۃf[^
	uint32 targetLength;	//Ώۃf[^̃oCg
	byte* dn;				//ɎgpؖsubjectA܂͂̔F؃`F[̏ؖsubject(2005.6.3 CHMC)
	uint32 dnLength;		//dñoCg(2005.6.3 CHMC)
	byte* outBuffer;		//o̓obt@
	uint32 bufferLength;	//o̓obt@̃obt@
	uint32 outLength;		//o̓e[_
	int result;				//ʃR[h
} DigitalSignStatus;
/*** PTX-804 BREW101 END ***/

typedef struct IDigitalSign IDigitalSign;
AEEINTERFACE(IDigitalSign) {
	INHERIT_IWebOpts(IDigitalSign);

	int (*ComputeDigitalSign)(IDigitalSign* po, DigitalSignStatus* status, AEECallback* pcb);
};

#define IDIGITALSIGN_AddRef(p)                 AEEGETPVTBL((p),IDigitalSign)->AddRef((p))
#define IDIGITALSIGN_Release(p)                AEEGETPVTBL((p),IDigitalSign)->Release((p))
#define IDIGITALSIGN_QueryInterface(p,i,o)     AEEGETPVTBL((p),IDigitalSign)->QueryInterface((p),(i),(o))
#define IDIGITALSIGN_AddOpt(p,o)               AEEGETPVTBL((p),IDigitalSign)->AddOpt((p),(o))
#define IDIGITALSIGN_RemoveOpt(p,i,n)          AEEGETPVTBL((p),IDigitalSign)->RemoveOpt((p),(i),(n))
#define IDIGITALSIGN_GetOpt(p,i,n,o)           AEEGETPVTBL((p),IDigitalSign)->GetOpt((p),(i),(n),(o))
#define IDIGITALSIGN_ComputeDigitalSign(p,io,cb) \
                                               AEEGETPVTBL((p),IDigitalSign)->ComputeDigitalSign((p),(io),(cb))

#endif //__AEEDIGITALSIGN_H__

