/* ------------------------------------------------------------------------------ */
/* KDDI_InputMode.h                                                               */
/* for KDDI BREW3.1 handset 2004-08-29                                            */
/* vdl 1.0.2     2004-12-21 łɔC [Brew3.1 KDDI Spec 1.0.2]   */
/*                          2005-04-26 RpCG[Ή(0x5c܂SJISR[h) */
/*                                     (RgubNRgƂ)         */
/* ------------------------------------------------------------------------------ */
/******************************************************************************
//  [PTX-804C]
//      PTX-804 BREW-20050523001 NJK  
//              050427-KDDI Extension}[W
******************************************************************************/

#ifndef _KDDI_INPUTMODE_H_
#define _KDDI_INPUTMODE_H_

#define TMJ_FEPIN        0x8000 /*(1000 0000 0000 0000) FEP͊Jn */
#define TMJ_FEPOUT       0x8001 /*(1000 0000 0000 0001) FEP͏I */

#define TMJ_RESERVE      0x4000 /*(0100 0000 0000 0000) ps(\) */
#define TMJ_ZENKAN       0x4001 /*(0100 0000 0000 0001) Sp͉\ */
#define TMJ_ZENICON      0x4002 /*(0100 0000 0000 0010) SpG͉\ */
#define TMJ_HANNUM       0x4004 /*(0100 0000 0000 0100) pl͉\ */
#define TMJ_ZENNUM       0x4008 /*(0100 0000 0000 1000) Spl͉\ */
#define TMJ_HANKATAKANA  0x4010 /*(0100 0000 0001 0000) pJ^Ji͉\ */
#define TMJ_ZENKATAKANA  0x4020 /*(0100 0000 0010 0000) SpJ^Ji͉\ */
#define TMJ_HANROMA      0x4040 /*(0100 0000 0100 0000) p + p󔒓͉\ */
#define TMJ_ZENROMA      0x4080 /*(0100 0000 1000 0000) Spp͉\ */
#define TMJ_HANKIGO      0x4100 /*(0100 0001 0000 0000) pL͉\ */
#define TMJ_ZENKIGO      0x4200 /*(0100 0010 0000 0000) SpL͉\ */
/* [Brew3.1 KDDI Spec 1.0.2] Start. */
#define TMJ_TAILE_CURSOR 0x4400 /*(0100 0100 0000 0000) FEPCJ[\𖖔ֈړ */
#define TMJ_HANROMA_IN   0x4800 /*(0100 1000 0000 0000) ppftHgĕ\ */
/* [Brew3.1 KDDI Spec 1.0.2] End.   */

#define TMJ_HANKIGO_MAIL 0x5000 /*(0101 0000 0000 0000) [(płȂpL h<>()\) */
#define TMJ_TELNO        0x5001 /*(0101 0000 0000 0001) p0-9,*,#,-,P͂\ */

#endif /*_KDDI_INPUTMODE_H_ */
