#ifndef __OEMMPNET_H__
#define __OEMMPNET_H__
/******************************************************************************
// COPYRIGHT    : \j[
// DIVISION     : DTNC CSED
// AUTHOR       : NJK Narutomi
// FILENAME     : OEMMPNET.h
//
// @(s) CONTENT : OEMMPNET.h
//
// FUNCTION		:
//
// VERSION      : $Revision:$
// HISTORY      : -------- Tv -----------------------------------------------
//
//
// [ PTX-805 ]
//	Version		UIQ/TRK	OutLine
//						VK쐬
//
// [ PTX-808 ]
//	Version		UIQ/TRK	OutLine
//	00.10.00 			PTX-808 BREW301 20060110001 NJK 
//						[PTX-805 TRK3752 }[W]
//						ZԂɒʐMNGXgsƁAʐMNGXgĂȂȂsΉ
//
// @(h) OEMMPNET.h ver 1.00 ( '2005.08.26 NJK narutomi)
//
******************************************************************************/


#include "AEE.h"
#include "AEEWeb.h"
#include "AEEMPNet.h"
#include "ApiBrowser.h"
#include "BrewNap.h"

#define IMP_HEAD_MAX (1024*64+1500)
#define IMP_URL_MAX (1024)

typedef struct _OEMMPNET OEMMPNET;

struct _OEMMPNET
{

//	const VTBL(IMPNET) * pvt;
	const VTBL(IMPNet) *pvt;
	uint32 m_nRefs;
	AEECLSID m_clsid;

	IShell * m_pIShell;

	ST_BREW_NATIVE_IMPRECV s;

	short cancle_f;									//LZtO
	short callb_f;									//R[obNG[tO
	short req_f;									//NGXgtO
	void* m_pac;									// point to App Context
	int callbacknum;								// EventNumber							/*** PTX-808 BREW301 ***/

	char ap_url_buf[IMP_URL_MAX+1];					//AvbgAhXobt@
	char ap_header_buf[IMP_HEAD_MAX+1];				//Avbgwb_obt@
	char ap_entity_buf[BRW_HTTP_MAX_PDU_SIZE+1];		//AvbgGeBeBobt@
	char header_buf[IMP_HEAD_MAX+1];					//wb_obt@
	char response_buf[BRW_HTTP_MAX_PDU_SIZE+1];		//X|Xobt@
	char url_buf[IMP_URL_MAX+1];						//AhXobt@

	PFNMPNETSTARTNOTIFY pfnhead;
	PFNMPNETBODYNOTIFY pfnbody;
	PFNMPNETENDNOTIFY pfnfin;

};

// Av^XNIMPNetɒʒmp[^
typedef struct {
	char 			*phead_buf;
	unsigned short 	status;
	char			*pbody_buf;
	char			*purl_buf;
	int  			entity_size;
	boolean			res_flag;
}ST_BREW_EVENT_IMPNET;


#endif /* __OEMMPNET_H__ */
